package com.jsevy.jodg;

import java.awt.Graphics2D;
import java.util.Vector;

import com.jsevy.jxml.XMLElement;



class ODGStyles extends XMLElement
{
    private static int styleCount = 0;
    
    private Vector<ODGStyle> styles = new Vector<ODGStyle>();
    
    
    public ODGStyles()
    {
        styles = new Vector<ODGStyle>();
        
        populateXML();
    }
    
    
    private void populateXML()
    {
        this.setNodeName("office:automatic-styles");
    }
    
    public synchronized static String getNextName()
    {
        styleCount++;
        return "style_" + styleCount;
    }
    
    
    public synchronized ODGGraphicsStyle getGraphicsStyle(Graphics2D graphics, boolean stroked, boolean filled)
    {
        ODGGraphicsStyle newStyle = new ODGGraphicsStyle(graphics, stroked, filled);
        
        int index = styles.indexOf(newStyle);
        
        if (index < 0)
        {
            // not found; add and return new style
            styles.add(newStyle);
            this.appendChild(newStyle);
            return newStyle;
        }
        else
        {
            // decrement style count, since incremented when created new style; 
            // not really needed, but why not - but really should synchronize
            styleCount--;
            return (ODGGraphicsStyle)styles.elementAt(index);
        }
    }
    
    
    public synchronized ODGTextStyle getTextStyle(Graphics2D graphics)
    {
        ODGTextStyle newStyle = new ODGTextStyle(graphics);
        
        int index = styles.indexOf(newStyle);
        
        if (index < 0)
        {
            // not found; add and return new style
            styles.add(newStyle);
            appendChild(newStyle);
            return newStyle;
        }
        else
        {
            // decrement style count, since incremented when created new style; 
            // not really needed, but why not - but really should synchronize
            styleCount--;
            return (ODGTextStyle)styles.elementAt(index);
        }
    }
    
    
}
